<?php
/*
Plugin Name: Hello World
Plugin URI: http://www.estrellateyarde.es/discover/manual-de-wordpress-como-crear-un-plugin
Description: Hello World es un plugin de ejemplo que imprime un saludo. Incluye shortcode. Ha sido programado exclusivamente con fines didácticos.
Version: 1.0
Author: crash-n-burn
Author URI: http://www.estrellateyarde.es
*/

/*
Copyright 2009  crash-n-burn  (email: webmaster@estrellateyarde.es)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
*/

// registrar la función que se ejecuta al activar el plugin
register_activation_hook(__FILE__, 'helloworld_activate');
// función que se ejecuta al activar el plugin
function helloworld_activate() {
	// crear la tabla del plugin e insertar dos registros
	global $wpdb; 
	$table_name= $wpdb->prefix."helloworld";

   	$sql = "CREATE TABLE $table_name (
		`id` mediumint( 9 ) NOT NULL auto_increment,
		`type` tinytext NOT NULL,
		`saludo` tinytext NOT NULL,
		PRIMARY KEY  (`id`)
		)";
	$wpdb->query($sql);

	$sql = "INSERT INTO $table_name (`id`, `type`, `saludo`) VALUES (1, 'default', 'Hello World')";
	$wpdb->query($sql);

	$sql = "INSERT INTO $table_name (`id`, `type`, `saludo`) VALUES (2, 'custom', 'Hola Mundo')";
	$wpdb->query($sql);

	// añadir la option del plugin
	add_option('helloworld_saludo_type', 'default');
}

// registrar la función que se ejecuta al desactivar el plugin
register_deactivation_hook(__FILE__, 'helloworld_deactivate');
// función que se ejecuta al desactivar el plugin
function helloworld_deactivate() {
	// borrar la tabla del plugin
	global $wpdb;
	$table_name = $wpdb->prefix."helloworld";

	$sql = "DROP TABLE $table_name";
	$wpdb->query($sql);

	// borrar la option del plugin
	delete_option('helloworld_saludo_type');
}

// crear un item en el panel de administración
add_action('admin_menu', 'helloworld_menu');
// crear la página de opciones del plugin
function helloworld_menu() {
	add_options_page('Hello World plugin options', 'Hello World', 8, basename(__FILE__), 'helloworld_options');
}
// función que muestra la página de opciones del plugin
function helloworld_options() {
	// comprobar si la petición procede del form
	global $wpdb;
	$table_name = $wpdb->prefix."helloworld";
	if(isset($_POST['saludo_custom_new']) && !empty($_POST['saludo_custom_new'])) {	
		$sql = "UPDATE $table_name SET saludo ='{$_POST['saludo_custom_new']}' WHERE type='custom'";
		$wpdb->query($sql);
	}
	if(isset($_POST['saludo_type'])) {	
		update_option('helloworld_saludo_type', $_POST['saludo_type']);
	}

	// mostrar la página de opciones
	$saludo_default = $wpdb->get_var("SELECT saludo FROM $table_name WHERE type='default'" );
	$saludo_custom = $wpdb->get_var("SELECT saludo FROM $table_name WHERE type='custom'" );
	$saludo_type = get_option('helloworld_saludo_type');
	if ($saludo_type == "default") {
		$checked_default = "checked";
		$checked_custom = "";
	} else {
		$checked_default = "";
		$checked_custom = "checked";
	}
	echo "<div class='wrap'>\n";
	echo "<h2>Hello World plugin options</h2>\n";
	echo "<form method='post' action=''>\n";
	echo "Display:<br />\n";
	echo "<input type='radio' name='saludo_type' value='default' ".$checked_default." /> Message default (<b>".$saludo_default."</b>)<br />\n";
	echo "<input type='radio' name='saludo_type' value='custom' ".$checked_custom." /> Message custom (<b>".$saludo_custom."</b>)<br />\n";
	echo "New Message custom: <input type='text' name='saludo_custom_new' /><br />\n";
	echo "<input type='submit' name='update' value='Update' />\n";
	echo "</form>\n";
	echo "</div>\n";
}

// función del plugin para usar en PHP, devuelve un string
function helloworld() {
	// recuperar el saludo
	global $wpdb;
	$table_name = $wpdb->prefix."helloworld";
	$saludo_type = get_option('helloworld_saludo_type');
	$saludo = $wpdb->get_var("SELECT saludo FROM $table_name WHERE type='$saludo_type'" );
	// output del plugin
	return "<p>".$saludo."</p>\n";
}

// registrar la función que se ejecuta al llamar al shortcode
add_shortcode('helloworld', 'helloworld_shortcode');
// shortcode del plugin para usar en los post
function helloworld_shortcode($atts) {
	// el valor devuelto por return se inserta en el post en lugar del shortcode
	// no se debe usar echo sino return
	return helloworld();
}
?>

